//+------------------------------------------------------------------+
//|                                      eurjpy_m1_sar_fast_test.mq4 |
//|                              Copyright  2007, Mirakhmedov Anvar |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Mirakhmedov Anvar"


extern double step0 = 0.045;
extern double step1 = 0.045;
extern double rsibuy = 55;
extern double rsisell = 45;
extern double _point =8;
extern double StopLoss = 13;
extern double TakeProfit = 13;
extern double _point1 =41;
extern double _pointSAR =19;
extern double slippage = 1000;
extern int I=16;
extern int Ib=16;
extern double barend = 0;
extern double _pointbreak =0.01;
extern string NameExpert = "eurjpy_m1_sar_fast_test";
extern string NameSound = "alert.wav";
//-------    -----------------------------------
extern string _Parameters_b_Lots = "----------    ";
extern int LotsWayChoice  = 0;    //    :
                                  //  0-,
                                  //  1-  ,
                                  //  2--,
                                  //  3--,
extern double Lots        = 0.3;  //   
extern int LotsPercent    = 90;   //   
extern int LotsDeltaDepo  = 500;  //   
extern int LotsDepoForOne = 500;  //     
extern int LotsMax        = 1000; //   

//+------------------------------------------------------------------+
//|      (  ) |
//+------------------------------------------------------------------+
double GetSizeLot()
{
  double dLot;

  if (LotsWayChoice==0) dLot=Lots;

  //    
  if (LotsWayChoice==1)
  {
    dLot=MathCeil(AccountFreeMargin()/10000*LotsPercent)/100;
  }

  // -
  if (LotsWayChoice==2)
  {
    int k=LotsDepoForOne;
    for (double i=2; i<=LotsMax; i++)
    {
      k=k+i*LotsDeltaDepo;
      if (k>AccountFreeMargin())
      {
        dLot=(i-1)/10; break;
      }
    }
  }

  // -
  if (LotsWayChoice==3)
  {
    dLot=MathCeil((AccountFreeMargin()-LotsDepoForOne)/LotsDeltaDepo)/10;
  }

  if (dLot<0.1) dLot=0.1;
  return(dLot);
}
int start()
{
int ticket,ticket_1,ticket_2;
int _GetLastError = 0, _OrdersTotal = OrdersTotal();
    //----    
    for ( int z = _OrdersTotal - 1; z >= 0; z -- )
    {
  //----      ,   
        if ( !OrderSelect( z, SELECT_BY_POS ) )
        {
            _GetLastError = GetLastError();
         
            continue;
        }
 

 

        
        //----   -,
        if ( OrderType() == OP_BUY )
        {
            //----    0-  ,
     if((Open[Ib]-Close[0])> _point1*Point  || 
     (((Low[iLowest(NULL,0,MODE_LOW,barend,1)])-_pointbreak)>Close[0] && iSAR(NULL,0,step0,0.1,0)>Close[0])) 
         
                      
                //----  
                {
                if((OrderClose( OrderTicket(), OrderLots(), 
                    Bid, slippage, Green ) )!=false)
                  {  
                 Alert( "BuyOrderClose  ",OrderClosePrice() );
                 SendMail("Expert", "BuyOrderClose_CadJpy_m5" + DoubleToStr(Close[0],Digits));
                 PlaySound(NameSound);
                 }
                 
                else
                {
                Alert( " BuyOrderClose  ",_GetLastError );
              return(-1);
                 }
                 }   
            return(0);
         
        }    
        
        //----   -,
        if ( OrderType() == OP_SELL )
        {
        if((Close[0]-Open[Ib])> _point1*Point||
          (iSAR(NULL,0,step0,0.1,0)<Close[0]&& ((High[iHighest(NULL,0,MODE_HIGH,barend,1)])+_pointbreak)<Close[0]))
        
          {
                if((OrderClose( OrderTicket(), OrderLots(), 
                    Ask, slippage, Green ) )!=false)
                    {
                 Alert( "SellOrderClose  ",OrderClosePrice()  );
                 SendMail("Expert", "SellOrderClose_CadJpy_m5" + DoubleToStr(Close[0],Digits));
                 PlaySound(NameSound);
                 }
                else
                {
                Alert( " SellOrderClose  ",_GetLastError);
                return(-1);
                 }
                 }   
            return(0);
         
        }    
     }
        
//+------------------------------------------------------------------+
//|      ,    |
//| ,                        |
//+------------------------------------------------------------------+
         if(iSAR(NULL,0,step0,0.1,0)<Close[0] )
         
         
        {
      ticket = (OrderSend( Symbol(), OP_BUY,GetSizeLot(), Ask, slippage,
       Bid-StopLoss*Point,Ask+TakeProfit*Point,NameExpert,
               0, Green ) );
if(ticket<1) {Print("  1-  BUY #",GetLastError());return (0); }  
if (ticket>0) //Sleep(10000);
          { // 1-  ,  
                 
         ticket_1 = (OrderSend( Symbol(), OP_BUY,GetSizeLot(), Ask, slippage,
       Bid-StopLoss*Point,Ask+TakeProfit*Point,NameExpert,
              0, Green ) ); 
if(ticket_1<1) {Print("  2  BUY #",GetLastError());return (0); }    
if (ticket_1>0) // Sleep(10000);
         { //    ,   

      ticket_2 = (OrderSend( Symbol(), OP_BUY,GetSizeLot(), Ask, slippage,
       Bid-StopLoss*Point,Ask+TakeProfit*Point,NameExpert,
              0, Green ) );
           if(ticket_2<1)
          {Print("  3  BUY #",GetLastError());return (0); }   
         } 
       }    
     }

            
      if(iSAR(NULL,0,step0,0.1,0)>Close[0])
    {
        
        //----   
      ticket = (OrderSend( Symbol(), OP_SELL,GetSizeLot(), Bid, slippage,
        Ask+StopLoss*Point,Bid-TakeProfit*Point, NameExpert,
              0, Red ));
              
           if(ticket<1) {Print("  1-  BUY #",GetLastError());return (0); }  
if (ticket>0) //Sleep(10000);
          { // 1-  ,  
             
      ticket_1 = (OrderSend( Symbol(), OP_SELL,GetSizeLot(), Bid, slippage,
        Ask+StopLoss*Point,Bid-TakeProfit*Point, NameExpert,
             0, Red ));
              
          if(ticket_1<1) {Print("  2  BUY #",GetLastError());return (0); }    
if (ticket_1>0) // Sleep(10000);
         { //    ,          
      
      ticket_2 = (OrderSend( Symbol(), OP_SELL,GetSizeLot(), Bid, slippage,
        Ask+StopLoss*Point,Bid-TakeProfit*Point, NameExpert,
              0, Red ));               
                if(ticket_2<1)
          {Print("  3  BUY #",GetLastError());return (0); }   
         } 
       }    
     }
   
    return(0);
    
}